<template>
  <ObModal
    ref="modal"
    :size="modalSizeComputed"
    :title="titleModal"
    :title-second="titleSecondModal"
    :is-error="isErrorModal"
    @closed="resetData"
  >
    <ObForm
      ref="form"
      class="order-event-form"
      :ok-text="okText"
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isLoading"
      :is-submit-disabled="isSubmitDisabled"
      :btn-modal="btnModal"
      :is-read-only="isReadOnly"
      :is-error="isErrorModal"
      :is-new="isNew"
      @submit="onSubmitForm"
      @on-btn-modal="onEditClick"
    >
      <div class="cols">
        <div class="col-left">
          <transition name="notifyIn">
            <div
              v-if="isShowNotification"
              class="notification-block"
            >
              <i class="icon checked" />
              <div class="notification-block__content">
                Изменения сохранены
              </div>
            </div>
          </transition>
          <div
            v-if="isEditMode"
            class="title mb30 mt20"
          >
            Текущее значения события
          </div>
          <component
            ref="component"
            :is="currentForm"
            :form-data="isEditMode ? copyFormData : formData"
            :data-source="dataSource"
            :order="order"
            :is-new="isNew"
            :is-edit-mode="isEditMode"
            @change-field="onChangeField"
            @submit-form="submitForm"
          />
        </div>
        <div
          v-if="isEditMode"
          class="col-right"
        >
          <div class="title mb30 mt20">
            Поля для редактирования события
          </div>
          <component
            :is="currentForm"
            :form-data="formData"
            :data-source="dataSource"
            :order="order"
            :is-new="isNew"
            :is-edit-mode="isEditMode"
            :is-new-form="true"
            @change-field="onChangeField"
          />
          <div class="pencil">
            <i class="icon edit" />
          </div>
        </div>
      </div>
    </ObForm>
  </ObModal>
</template>

<script>
import api from '@/api'
import ObModal from 'common-components/src/obComponents/obModal'
import ObForm from 'common-components/src/obComponents/obForm'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import EventFormMixin from '@/components/Order/orderItem/execution/events/eventFormMixin'
import EventReasonsMixin from '@/components/Order/orderItem/execution/events/eventReasons/event-reasons-mixin'
import cloneDeep from 'clone-deep'
import { required, requiredIf } from 'vuelidate/lib/validators'
import { mapGetters } from 'vuex'

import DefaultForm from './default'
import DefectForm from './defect'
import LogistForm from './logist'
import DowntimeForm from './downtime'
import CargoStarted from './cargoStarted'
import CargoEnded from './cargoEnded'
import ArrivedFor from './arrivedFor'
import DepartedFrom from './departedFrom'
import ExternalNumber from './externalNumber'
import CosigneeOrConsignor from './cosigneeOrConsignor'
import Forwarding from './forwarding'
import ArrivingDelay from './arrivingDelay'
import AddPoint from './addPoint'
import RemovePoint from './removePoint'
import TariffChanged from './tariffChanged'
import OrderInfoSentForm from './orderInfoSent'
import AttorneyLettersChange from './attorneyLettersChange'

const setToValue = (obj, value, path) => {
  let i
  path = path.split('.')
  for (i = 0; i < path.length - 1; i++) {
    obj = obj[path[i]]
    if (!obj) break
  }

  if (obj) {
    obj[path[i]] = value
  }
}

export default {
  name: 'orderEventModal',
  mixins: [
    FormValidationMixin,
    EventFormMixin,
    EventReasonsMixin
  ],
  components: {
    ObModal,
    ObForm
  },
  data () {
    return {
      modalSize: 'md',
      editModalSize: 'double-md',
      isEditMode: false,
      isLoading: false,
      copyFormData: {},
      isShowNotification: false
    }
  },
  computed: {
    ...mapGetters({
      firstOrder: 'order/order'
    }),
    currentCode () {
      const code = this.dataSource.code || (this.dataSource.eventData && this.dataSource.eventData.eventTypeCode)
      return code ? code.toLowerCase() : ''
    },
    currentForm () {
      const componentMap = {
        add_point_event: AddPoint,
        arrived_for_loading: ArrivedFor,
        arrived_for_unloading: ArrivedFor,
        arriving_delay: ArrivingDelay,
        autosearch_canceled: DefaultForm,
        autosearch_started: DefaultForm,
        cargo_handling_ended: CargoEnded,
        cargo_handling_started: CargoStarted,
        carrier_assign_cancelled: DefaultForm,
        carrier_assigned: DefaultForm,
        carrier_confirmed: DefaultForm,
        consignee_changed: CosigneeOrConsignor,
        consignor_changed: CosigneeOrConsignor,
        created: DefaultForm,
        defect: DefectForm,
        deficiency: DefectForm,
        departed_from_loading: DepartedFrom,
        departed_from_unloading: DepartedFrom,
        downtime: DowntimeForm,
        draft_order_errors: DefaultForm,
        empty_supply_started: DefaultForm,
        external_number: ExternalNumber,
        forwarding_event: Forwarding,
        logist: LogistForm,
        overage: DefectForm,
        remove_point_event: RemovePoint,
        resources_assign_cancelled: DefaultForm,
        resources_assigned: DefaultForm,
        tariff_changed: TariffChanged,
        time_slot_changed: DefaultForm,
        tracking_started: DefaultForm,
        trip_cancelled: DefaultForm,
        trip_ended: DefaultForm,
        order_info_sent: OrderInfoSentForm,
        attorney_created: DefaultForm,
        attorney_changed: AttorneyLettersChange,
        attorney_signed: DefaultForm,
      }

      return componentMap[this.currentCode] || DefaultForm
    },
    defaultEventData () {
      const isExistReasons = Boolean(this.currentReasonsList?.length)

      let reasonValidator = {}

      if (['ARRIVING_DELAY'].includes(this.currentCode.toUpperCase())) {
        reasonValidator = {
          reasonUuid: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return isExistReasons
              })
            }
          },
        }
      }

      return {
        comment: {
          value: ''
        },
        fileUuids: {
          type: 'array',
          value: null
        },
        ...reasonValidator
      }
    },
    formModel () {
      const dataSource = this.dataSource
      const moment = this.$moment
      const context = this

      const formModelMap = {
        logist () {
          return {
            uuid: {
              value: null
            },
            logistUuid: {
              value: null,
              validator: {
                required
              }
            },
            ...context.defaultEventData
          }
        },
        external_number () {
          return {
            orderUuid: {
              value: () => context.order.uuid
            },
            oldNumber: {
              value: () => context.order.externalNumber
            },
            newNumber: {
              value: () => context.order.externalNumber,
              validator: {
                required
              }
            },
            ...context.defaultEventData
          }
        },
        carrier_assigned () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        carrier_assign_cancelled () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        carrier_confirmed () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        created () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        trip_cancelled () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        empty_supply_started () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        trip_ended () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        autosearch_started () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        resources_assigned () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        resources_assign_cancelled () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        tariff_changed () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                oldCarrierTariff: {},
                oldClientTariff: {},
                newCarrierTariff: {},
                newClientTariff: {},
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        time_slot_changed () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        downtime () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'DOWNTIME'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'DowntimeEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                duration: {
                  value: '',
                  validator: {
                    notNull: {
                      method: (value) => {
                        return Boolean(value)
                      },
                      error: 'Должно быть не менее 1'
                    }
                  }
                },
                amount: {
                  value: 0,
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        arriving_delay () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'ARRIVING_DELAY'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'ArrivingDelayEvent'
                },
                visitPointUuid: {
                  value: () => dataSource.point?.visitPointUuid
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                delay: {
                  value: '',
                  validator: {
                    notNull: {
                      method: (value) => {
                        return Boolean(value)
                      },
                      error: 'Должно быть не менее 1'
                    }
                  }
                },
                amount: {
                  value: 0,
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        defect () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'DEFECT'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'CargoProblem'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                unitQty: {
                  value: 1,
                  validator: {
                    required
                  }
                },
                amount: {
                  value: '',
                  validator: {
                    required
                  }
                },
                forwardingUnitUuid: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        deficiency () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'DEFICIENCY'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'CargoProblem'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                unitQty: {
                  value: 1,
                  validator: {
                    required
                  }
                },
                amount: {
                  value: '',
                  validator: {
                    required
                  }
                },
                forwardingUnitUuid: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        overage () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'OVERAGE'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'CargoProblem'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                unitQty: {
                  value: 1,
                  validator: {
                    required
                  }
                },
                amount: {
                  value: '',
                  validator: {
                    required
                  }
                },
                forwardingUnitUuid: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        cargo_handling_started () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'CARGO_HANDLING_STARTED'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        cargo_handling_ended () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'CARGO_HANDLING_ENDED'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        arrived_for_loading () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'arrived_for_loading'
                },
                comment: {
                  value: '',
                  validator: {
                    dateAfter: {
                      method: (value) => {
                        return dataSource.specialParameters?.eventDt && this?.formData?.specialParameters?.eventDt
                          ? moment(this.formData.specialParameters.eventDt).diff(moment(dataSource.specialParameters.eventDt)) <= 0 || Boolean(value)
                          : true
                      },
                      error: 'Укажите причину опоздания'
                    }
                  }
                },
                fileUuids: {
                  value: null
                }
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        arrived_for_unloading () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'arrived_for_unloading'
                },
                comment: {
                  value: '',
                  validator: {
                    dateAfter: {
                      method: (value) => {
                        return dataSource.specialParameters?.eventDt && this?.formData?.specialParameters?.eventDt
                          ? moment(this.formData.specialParameters.eventDt).diff(moment(dataSource.specialParameters.eventDt)) <= 0 || Boolean(value)
                          : true
                      },
                      error: 'Укажите причину опоздания'
                    }
                  }
                },
                fileUuids: {
                  value: null
                }
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        departed_from_loading () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'departed_from_loading'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        departed_from_unloading () {
          return {
            eventData: {
              nested_fields: {
                entityUuid: {
                  value: () => context.order.tripUuid
                },
                entityType: {
                  value: 'TRIP'
                },
                eventTypeCode: {
                  value: 'departed_from_unloading'
                },
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TerminalProcessingEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                },
                pointUuid: {
                  value: () => context.dataSource.point?.uuid
                },
                visitPointUuid: {
                  value: () => context.dataSource.point?.visitPointUuid
                },
                eventDt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            }
          }
        },
        tracking_started () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        consignee_changed () {
          return {
            ...context.defaultEventData,
            eventDt: {
              value: () => new Date()
            },
            suborderUuid: {
              value: () => context.order.uuid
            },
            visitPointUuid: {
              value: () => context.dataSource.point?.visitPointUuid
            },
            orderUuid: {
              value: () => context.firstOrder.uuid
            },
            eventType: {
              value: 'TripEvent'
            },
            consigneeOrConsignor: {
              value: 'CONSIGNEE'
            },
            consigneeOrConsignorUuidOld: {
              value: () => context.dataSource.consigneeOrConsignorUuid
            },
            consigneeOrConsignorUuidNew: {
              value: '',
              validator: {
                required
              }
            },
            tsdAddress: {
              value: '',
              validator: {
                required
              }
            }
          }
        },
        consignor_changed () {
          return {
            ...context.defaultEventData,
            eventDt: {
              value: () => new Date()
            },
            suborderUuid: {
              value: () => context.order.uuid
            },
            visitPointUuid: {
              value: () => context.dataSource.point?.visitPointUuid
            },
            orderUuid: {
              value: () => context.firstOrder.uuid
            },
            eventType: {
              value: 'TripEvent'
            },
            consigneeOrConsignor: {
              value: 'CONSIGNOR'
            },
            consigneeOrConsignorUuidOld: {
              value: () => context.dataSource.consigneeOrConsignorUuid
            },
            consigneeOrConsignorUuidNew: {
              value: '',
              validator: {
                required
              }
            },
            tsdAddress: {
              value: '',
              validator: {
                required
              }
            }
          }
        },
        forwarding_event () {
          const specialParameters = {
            visitPointUuid: {
              value: '',
              validator: {
                required
              }
            },
            newVisitPointData: {
              nested_fields: {
                addressTitle: {
                  value: '',
                  validator: {
                    required
                  }
                },
                direction: {
                  value: '',
                  validator: {
                    required
                  }
                },
                coordinates: {
                  nested_fields: {
                    lat: {
                      value: ''
                    },
                    lon: {
                      value: ''
                    }
                  }
                },
                consigneeOrConsignor: {
                  value: '',
                  validator: {
                    required
                  }
                },
                consigneeOrConsignorUuid: {
                  value: '',
                  validator: {
                    required
                  }
                },
              }
            },
            newTimeSlot: {
              nested_fields: {
                slotStartAt: {
                  value: '',
                  validator: {
                    required
                  }
                },
                slotEndAt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            newClientTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            newCarrierTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required: requiredIf(function () {
                      return Boolean(dataSource.subOrders && dataSource.subOrders.length === 1 && dataSource.subOrders[0].contractorUuid)
                    })
                  }
                }
              }
            }
          }
          if (context.isNew) {
            return {
              ...context.defaultEventData,
              ...specialParameters,
              orderUuid: {
                value: () => context.order.uuid,
                validator: {
                  required
                }
              }
            }
          } else {
            return {
              eventData: {
                ...context.defaultEventData
              },
              specialParameters
            }
          }
        },
        draft_order_errors () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        },
        add_point_event () {
          const specialParameters = {
            visitPointUuid: {
              value: '',
              validator: {
                required
              }
            },
            newVisitPointData: {
              nested_fields: {
                addressTitle: {
                  value: '',
                  validator: {
                    required
                  }
                },
                direction: {
                  value: '',
                  validator: {
                    required
                  }
                },
                coordinates: {
                  nested_fields: {
                    lat: {
                      value: ''
                    },
                    lon: {
                      value: ''
                    }
                  }
                },
                consigneeOrConsignor: {
                  value: '',
                  validator: {
                    required
                  }
                },
                consigneeOrConsignorUuid: {
                  value: '',
                  validator: {
                    required
                  }
                },
              }
            },
            newTimeSlot: {
              nested_fields: {
                slotStartAt: {
                  value: '',
                  validator: {
                    required
                  }
                },
                slotEndAt: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            newClientTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            newCarrierTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required: requiredIf(function () {
                      return Boolean(dataSource.subOrders && dataSource.subOrders.length === 1 && dataSource.subOrders[0].contractorUuid)
                    })
                  }
                }
              }
            }
          }
          if (context.isNew) {
            return {
              ...context.defaultEventData,
              ...specialParameters,
              orderUuid: {
                value: () => context.order.uuid,
                validator: {
                  required
                }
              }
            }
          } else {
            return {
              eventData: {
                ...context.defaultEventData
              },
              specialParameters
            }
          }
        },
        remove_point_event () {
          const specialParameters = {
            visitPointUuid: {
              value: '',
              validator: {
                required
              }
            },
            newClientTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            oldCarrierTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: ''
                }
              }
            },
            newCarrierTariff: {
              nested_fields: {
                priceWithoutVat: {
                  value: ''
                },
                vatPrice: {
                  value: ''
                },
                vatRate: {
                  value: ''
                },
                priceWithVat: {
                  value: '',
                  validator: {
                    required: requiredIf(function () {
                      return Boolean(dataSource.subOrders && dataSource.subOrders.length === 1 && dataSource.subOrders[0].contractorUuid)
                    })
                  }
                }
              }
            }
          }
          if (context.isNew) {
            return {
              ...context.defaultEventData,
              ...specialParameters,
              orderUuid: {
                value: () => context.order.uuid,
                validator: {
                  required
                }
              }
            }
          } else {
            return {
              eventData: {
                ...context.defaultEventData
              },
              specialParameters
            }
          }
        },
        order_info_sent () {
          return {
            tripUuid: {
              value: () => context.order.tripUuid
            },
            suborderUuid: {
              value: () => context.order.uuid
            },
            comment: {
              value: ''
            },
            ...context.defaultEventData
          }
        },
        attorney_changed () {
          // {
          //   "orderUuid": "f137cc91-316f-47f7-9e22-85fef29d5ea3",
          //   "suborderUuid": "f137cc91-316f-47f7-9e22-85fef29d5ea3",
            //   "consignor": {
          //   "uuid": "f137cc91-316f-47f7-9e22-85fef29d5ea3",
          //     "title": "ООО Ромашка"
          // },
          //   "driver": {
          //   "uuid": "f137cc91-316f-47f7-9e22-85fef29d5ea3",
          //     "fio": "Васильева Дарья",
          //     "phone": "79778015997"
          // },
          //   "materialValues": "Бутилированная вода",
          //   "unitTitle": "Бутылок",
          //   "unitValue": 10,
          //   "comment": "Комментарий",
          //   "files": [
          //   "f137cc91-316f-47f7-9e22-85fef29d5ea3"
          // ]
          // }

          const specialParameters = {
            suborderUuid: {
              value: '',
              validator: {
                required
              }
            },
            driver: {
              nested_fields: {
                uuid: {
                  value: '',
                  validator: {
                    required
                  }
                },
                fio: {
                  value: '',
                  validator: {
                    required
                  }
                },
                phone: {
                  value: '',
                  validator: {
                    required
                  }
                }
              }
            },
            materialValues: {
              value: '',
              validator: {
                required
              }
            },
            unitTitle: {
              value: '',
              validator: {
                required
              }
            },
            unitValue: {
              value: '',
              validator: {
                required
              }
            }
          }
          if (context.isNew) {
            return {
              ...context.defaultEventData,
              ...specialParameters,
              orderUuid: {
                value: () => context.order.uuid,
                validator: {
                  required
                }
              },
              consignor: {
                value: () => context.order.consignors[0]
              }
            }
          } else {
            return {
              eventData: {
                ...context.defaultEventData
              },
              specialParameters
            }
          }
        },
        default () {
          return {
            eventData: {
              nested_fields: {
                ...context.defaultEventData
              }
            },
            specialParameters: {
              nested_fields: {
                eventType: {
                  value: 'TripEvent'
                },
                suborderUuid: {
                  value: () => context.order.uuid
                }
              }
            }
          }
        }
      }

      const model = formModelMap[this.currentCode] || formModelMap.default

      return model()
    },
    createMethod () {
      let methodsMap = {
        logist: ({ data }) => {
          if (this.order.isSuborder) {
            return api.orderProcess.setSuborderLogist({ uuid: this.order.uuid, data })
          } else {
            return api.orderProcess.setOrderLogist({ uuid: this.order.uuid, data })
          }
        },
        external_number: ({ data }) => {
          return api.orderProcess.changeExternalNumber({ data })
        },
        consignor_changed: ({ data }) => {
          return api.orderProcess.changeConsignorOrConsigneeEvent({ data })
        },
        consignee_changed: ({ data }) => {
          return api.orderProcess.changeConsignorOrConsigneeEvent({ data })
        },
        forwarding_event: ({ data }) => {
          return api.orderProcess.forwardingEvent({ data })
        },
        add_point_event: ({ data }) => {
          data.visitPointUuid = data.visitPointUuid === 'last' ? null : data.visitPointUuid
          return api.orderProcess.addPointEvent({ data })
        },
        remove_point_event: ({ data }) => {
          return api.orderProcess.removePointEvent({ data })
        },
        autosearch_canceled: ({ data }) => {
          return api.orderProcess.autosearchCancel({ uuid: this.order.uuid, data: data.eventData })
        },
        order_info_sent: ({ data }) => {
          return api.orderProcess.sendOrderInfo({ data })
        },
        attorney_changed: ({ data }) => {
          data.files = data.fileUuids
          return api.orderProcess.saveAttorneyLetters({ data })
        },
        default: ({ data }) => {
          return api.orderProcess.createEvent({ data })
        }
      }

      return methodsMap[this.currentCode] || methodsMap.default
    },
    updateMethod () {
      return ({ data }) => {
        return api.orderProcess.updateEvent({ uuid: this.dataSource.uuid, data })
      }
    },
    modalSizeComputed () {
      return this.isEditMode ? this.editModalSize : this.modalSize
    },
    isSubmitDisabled () {
      return this.formData.fileUuids === 'loading' || undefined
    },
    isNew () {
      return !this.dataSource.uuid
    },
    isCancelledOrder () {
      return this.order.status === 'CANCELED'
    },
    isReadOnly () {
      return (!this.isNew && !this.isEditMode) || this.isCancelledOrder
    },
    okText () {
      const addTextMap = {
        defect: 'Добавить',
        logist: 'Изменить',
        external_number: 'Изменить',
        consignor_changed: 'Сменить ГО',
        consignee_changed: 'Сменить ГП',
        add_point_event: 'Добавить допточку',
        remove_point_event: 'Удалить допточку',
        autosearch_canceled: 'Остановить',
        attorney_changed: 'Изменить доверенность'
      }
      const editTextMap = {}
      if (this.isNew) {
        return addTextMap[this.currentCode] || 'Добавить'
      }

      return editTextMap[this.currentCode] || 'Сохранить'
    },
    btnModal () {
      if (this.isEditMode ||
        this.isNew ||
        this.isCancelledOrder ||
        !this.order.isEditable ||
        this.currentCode === 'order_info_sent'
      ) return ''

      return 'Редактировать'
    },
    titleModal () {
      const formModelMap = {
        defect: this.isNew ? 'Фиксация брака' : 'Брак',
        overage: this.isNew ? 'Фиксация излишка' : 'Излишек',
        deficiency: this.isNew ? 'Фиксация недостачи' : 'Недостача',
        logist: this.isNew ? 'Смена ответственного' : 'Ответственный сменен',
        downtime: this.isNew ? 'Простой' : 'Простой',
        carrier_assigned: 'Исполнитель заказа назначен',
        carrier_assign_cancelled: 'Назначение исполнителя отменено',
        resources_assigned: 'Ресурсы назначены',
        resources_assign_cancelled: 'Ресурсы сняты',
        created: 'Рейс создан',
        trip_cancelled: 'Рейс отменён',
        empty_supply_started: 'Начата подача порожнего',
        trip_ended: 'Рейс завершился',
        arrived_for_loading: 'Прибыл на погрузку',
        arrived_for_unloading: 'Прибыл на разгрузку',
        departed_from_loading: 'Убыл с погрузки',
        departed_from_unloading: 'Убыл с разгрузки',
        autosearch_started: 'Автопоиск запущен',
        carrier_confirmed: 'Исполнитель подтверждён',
        tariff_changed: 'Тариф изменён',
        time_slot_changed: 'Изменён тайм-слот',
        cargo_handling_started: this.isNew ? 'Фиксация начала ПРР' : 'Начало ПРР',
        cargo_handling_ended: this.isNew ? 'Фиксация окончания ПРР' : 'Окончание ПРР',
        tracking_started: 'Трекинг начался',
        external_number: 'Изменение номера заказа клиента',
        consignor_changed: 'Смена грузоотправителя',
        consignee_changed: 'Смена грузополучателя',
        forwarding_event: this.isNew ? 'Оформление переадресации' : 'Переадресация',
        arriving_delay: this.isNew ? 'Фиксация опоздания' : 'Опоздание',
        add_point_event: this.isNew ? 'Добавление допточки' : 'Допточка добавлена',
        remove_point_event: this.isNew ? 'Удаление точки' : 'Точка удалена',
        autosearch_canceled: this.isNew ? 'Остановка автопоиска' : 'Автопоиск остановлен',
        draft_order_errors: 'ЭТП ГП',
        order_info_sent: 'Отправка информации по заказу Клиенту',
        attorney_created: 'Доверенность сформирована',
        attorney_changed: this.isNew ? 'Изменение доверенности' : 'Доверенность изменена',
        attorney_signed: 'Доверенность подписана',
      }
      return formModelMap[this.currentCode] || this.dataSource.eventData?.title
    },
    titleSecondModal () {
      if (this.isNew) return ''

      return this.isEditMode ? 'редактирование' : ''
    },
    isErrorModal () {
      if (!this.isNew) return false

      const errorMap = {
        remove_point_event: true
      }

      return errorMap[this.currentCode] || false
    },
    successMessage () {
      if (!this.isNew) return 'Изменения сохранены'

      const messageMap = {
        autosearch_canceled: 'Автопоиск остановлен',
      }

      return messageMap[this.currentCode] || 'Событие добавлено'
    },
    errorMessage () {
      return 'Ошибка сохранения события'
    },
    currentReasonsList () {
      return this.reasonsList[this.currentCode?.toUpperCase()] || []
    }
  },
  methods: {
    onSubmitForm (data) {
      if (this.isNew && this.$refs.component?.isConfirmable && this.$refs.component.showConfirmModal) {
        this.$refs.component.showConfirmModal()
      } else {
        this.submitForm(data)
      }
    },
    async submitForm (data = this.formData) {
      try {
        this.isLoading = true
        let eventNameByEventCode = this.currentCode.replace('_', '-')

        if (this.isNew) {
          await this.createMethod({ data })
          this.$emit('created', { uuid: this.dataSource.uuid })
          this.$emit(eventNameByEventCode)
          this.close()
          this.$notification({ type: 'system_notification_success', message: this.successMessage })
        } else {
          await this.updateMethod({ data })
          this.$emit('updated', {
            uuid: this.dataSource.uuid,
            eventTypeCode: this.currentCode.toUpperCase()
          })
          this.$emit(eventNameByEventCode)
          this.isEditMode = false
          this.showNotification()
        }
      } catch (e) {
        this.$notification({ type: 'system_notification_error', message: e?.message || this.errorMessage })
      } finally {
        this.isLoading = false
      }
    },
    showNotification () {
      this.isShowNotification = true
    },
    onChangeField ({ path, value }) {
      setToValue(this.formData, value, path)
    },
    open () {
      this.$refs.modal.open()
    },
    close () {
      this.$refs.modal.close()
    },
    resetData () {
      this.isEditMode = false
      this.isShowNotification = false
    },
    onEditClick () {
      this.isShowNotification = false
      this.copyFormData = cloneDeep(this.formData)
      this.isEditMode = true
    },
    async afterInitForm () {
      this.$refs.form && this.$refs.form.resetForm()
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.order-event-form {
  &::v-deep {
    .row {
      margin-top: 20px;
      margin-bottom: 20px;
    }
    .title, .group-title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
  .mb30 {
    margin-bottom: 30px!important;
  }
  .mt20 {
    margin-top: 20px!important;
  }
  .cols {
    display: flex;
    justify-content: space-between;
    .col-left {
      width: 580px;
    }
    .col-right {
      position: relative;
      width: 620px;
      padding: 0 20px;
      margin-left: 20px;
      margin-right: 20px;
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: calc(100% + 20px);
        border: 1px dashed $gray-window;
        border-radius: 3px;
        pointer-events: none;
      }
      .pencil {
        position: absolute;
        top: -12px;
        right: -12px;
        display: flex;
        width: 24px;
        height: 24px;
        justify-content: center;
        align-items: center;
        border: 1px dashed $gray-window;
        border-radius: 50%;
        background-color: #fff;
        .icon {
          color: $gray-window;
          font-size: 14px;
        }
      }
    }
  }

  .notification-block {
    display: flex;
    margin-bottom: 30px;
    padding: 20px 48px 20px 18px;
    border-left: 6px solid $Green-700;
    box-shadow: 0 4px 20px rgba(25, 30, 50, 0.2);
    & > i {
      margin-right: 20px;
      font-size: 24px;
      color: $Green-700;
    }
    &__content {
      padding-top: 2px;
      @include font-mixin(14px, 18px, 400);
    }
  }

  .notifyIn-enter {
    opacity: 0;
  }

  .notifyIn-enter-active {
    transition: opacity .3s ease-in-out;
  }
}
</style>
